package moraxus.server;

import moraxus.server.storage.AppEngineStorage;
import moraxus.server.storage.Storage;
import moraxus.server.user.AppEngineAuthenticator;
import moraxus.server.user.Authenticator;

public class Configuration {
	// Storage solution
	private static int STORAGE_PROVIDER=1;
	
	private final static int GOOGLE_APPENGINE_STORAGE=1;
	
	// User authentication
	private static int USER_AUTHENTICATOR=1;
	
	private final static int GOOGLE_APPENGINE_USER=1;
	
	
	public static Storage getStorage(){
		switch (STORAGE_PROVIDER) {
        	case GOOGLE_APPENGINE_STORAGE:
        		return new AppEngineStorage();
        	default:
        		return new AppEngineStorage();
		}
	}
	
	public static Authenticator getAuthenticator(){
		switch (USER_AUTHENTICATOR) {
        	case GOOGLE_APPENGINE_USER:
        		return new AppEngineAuthenticator();
        	default:
        		return new AppEngineAuthenticator();
		}
	}
}
