package moraxus.server;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.tomcat.util.buf.UTF8Decoder;

import moraxus.server.user.Authenticator;
import moraxus.server.user.User;

@SuppressWarnings("serial")
public class UserServlet extends HttpServlet {
	public void doGet(HttpServletRequest req, HttpServletResponse resp) throws IOException, ServletException {
		Authenticator auth=Configuration.getAuthenticator();
		
		String method=req.getParameter("method");
		if(method==null){
			OutputWriter.write(resp, HttpServletResponse.SC_BAD_REQUEST, req.getParameter("format"), new OutMessage("error", "no method provided"));
			return;
		}else if(method.equalsIgnoreCase("getUser")){
			// Get the logged in user
			User user=auth.getCurrentUser(req);
			String destinationUrl=req.getParameter("destinationUrl");
			if(destinationUrl==null)
				destinationUrl="";

			// Return login link if not logged in
			if(user==null){
				OutputWriter.write(resp, HttpServletResponse.SC_ACCEPTED, req.getParameter("format"), new OutMessage[]{new OutMessage("userId", "-1"), new OutMessage("loginUrl", auth.getLoginURL(req, destinationUrl))});
			}else{// Return userId and logout url
				OutputWriter.write(resp, HttpServletResponse.SC_ACCEPTED, req.getParameter("format"), new OutMessage[]{new OutMessage("userId", user.getId()), new OutMessage("logoutUrl", auth.getLogoutURL(req, destinationUrl))});
			}
		}else{
			OutputWriter.write(resp, HttpServletResponse.SC_BAD_REQUEST, req.getParameter("format"), new OutMessage("error", "invalid method"));
			return;
		}
	}

	public void doPost(HttpServletRequest req, HttpServletResponse resp) throws IOException, ServletException {

	}
}