package moraxus.server.storage;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Content {
	private Map<String, String> properties=new HashMap<String, String>();
	private MoraxusKey key;
	private List<MoraxusKey> children=new ArrayList<MoraxusKey>();
	
	private boolean publicRead=true;
	private boolean publicWrite=false;
	
	private transient String apiKey;

	public Content(String type, String apiKey, String creatorId){
		this.apiKey=apiKey;
		properties.put("type", type);
		properties.put("creatorId", creatorId);
	}
	
	public Content(String type, String apiKey, String creatorId, MoraxusKey parentKey){
		this(type, apiKey, creatorId);
		properties.put("parentKey", parentKey.toString());
	}
	
	public void setProperty(String propertyName, Object propertyValue){
		properties.put(propertyName, propertyValue.toString());
	}
	
	public String getProperty(String propertyName){
		return properties.get(propertyName);
	}
	
	public Map<String, String> getProperties(){
		return properties;
	}
	
	public List<MoraxusKey> getChildren(){
		return children;
	}
	
	public void setChildren(List<MoraxusKey> children){
		this.children=children;
	}
	
	public void setKey(MoraxusKey key){
		this.key=key;
	}
	
	public MoraxusKey getKey(){
		return key;
	}

	public String getApiKey() {
		return apiKey;
	}
	
	public boolean canPublicWrite(){
		return publicWrite;
	}
	
	public boolean canPublicRead(){
		return publicRead;
	}
	
	public void setPublicWrite(boolean publicWrite){
		this.publicWrite=publicWrite;
	}
	
	public void setPublicRead(boolean publicRead){
		this.publicRead=publicRead;
	}
}
