package moraxus.server.storage;

import java.util.List;
import java.util.Map;

public interface Storage {
	public MoraxusKey getKeyFromPath(String path);
	public List<Content> search(MoraxusKey ancestor, String type);
	public List<Content> search(MoraxusKey ancestor, String type, Map<String, String> parameters);
	public Content getContent(MoraxusKey key);
	public List<MoraxusKey> getChildrenKeys(MoraxusKey parentKey);
	public MoraxusKey saveObject(Content c);
	public boolean hasReadAccess(String userId, String contentId);
	public boolean hasWriteAccess(String userId, String contentId);
	public void setReadAccess(String userId, String contentId);
	public void setWriteAccess(String userId, String contentId);
	public void delete(MoraxusKey key);
}
