package moraxus.server.user;

import javax.servlet.http.HttpServletRequest;

import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;

public class AppEngineAuthenticator implements Authenticator {

	@Override
	public User getCurrentUser(HttpServletRequest req) {
		UserService userService = UserServiceFactory.getUserService();
		com.google.appengine.api.users.User user = userService.getCurrentUser();

		if(user==null)
			return null;
		
		User myUser = new User(user.getUserId());

		return myUser;
	}
	
	@Override
	public String getLoginURL(HttpServletRequest req, String destinationUrl) {
		UserService userService = UserServiceFactory.getUserService();
		
		return userService.createLoginURL(destinationUrl);
	}

	@Override
	public String getLogoutURL(HttpServletRequest req, String destinationUrl) {
		UserService userService = UserServiceFactory.getUserService();
		
		return userService.createLogoutURL(destinationUrl);
	}
}
