var API_KEY="123456789";
var BASE_URL="http://127.0.0.1:8888/";
//var BASE_URL="http://moraxus-api.appspot.com/";
var USER_ID=-1;

function Blog(id, title, creator, creatorId){
	this.id=id;
	this.title=title;
	this.creator=creator;
	this.creatorId=creatorId;
}

function getUrlVars()
{
    var i;
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

function createBlog(){
	$.ajax({
		type: 'POST',
		url: BASE_URL + "content/blog", 
		data: {"type":"blog", "title": $('#titleInput').val() , "creator":  $('#creatorInput').val()},
		beforeSend: function(xhr) {xhr.setRequestHeader("apiKey", API_KEY)},
		success: function(resp) {
			$('#content').empty();
			$('#content').append("Great success! Visit your PRO blog <a href='blog.html?blogId=" + resp.key + "'>here!</a>");
		}, 
		dataType: "json"
	});
}

function postComment(){
	$.ajax({
		type: 'POST',
		url: BASE_URL + "content/blog/" + blogId + "/post/" + postId + "/comment/", 
		data: {"type":"comment", "content": $('#commentContent').val(), "name": $('#commentName').val()},
		beforeSend: function(xhr) {xhr.setRequestHeader("apiKey", API_KEY)},
		success: function(resp) {
			window.location = "post.html?blogId=" + blogId + "&postId=" + postId;
		}, 
		dataType: "json"
	});
}

function createPost(){
	$.ajax({
		type: 'POST',
		url: BASE_URL + "content/blog/" + blogId + "/post", 
		data: {"type":"post", "title": $('#titleInput').val(), "category": $('#categoryInput').val(), "content": $('#contentInput').val()},
		beforeSend: function(xhr) {xhr.setRequestHeader("apiKey", API_KEY)},
		success: function(resp) {
			window.location = "blog.html?blogId=" + blogId;
		}, 
		dataType: "json"
	});
}

function deletePost(){
	$.ajax({
		type: 'DELETE',
		url: BASE_URL + "content/blog/" + blogId + "/post/" + postId, 
		data: {},
		async: false,
		beforeSend: function(xhr) {xhr.setRequestHeader("apiKey", API_KEY)},
		success: function(resp) {

		}, 
		dataType: "json"
	});	
}

function getBlogPosts(blogId){
	$.get(
		BASE_URL + "content/blog/" + blogId + "/post",  
		{"type":"post"},
		function(data) {
			$.each(data, function(key, val) {
				$('#posts').append("<hr><h4>" + val.properties.title + "</h4>");
				$('#posts').append("<i>Category: " + val.properties.category + "</i><br />");
				$('#posts').append("<p>" + val.properties.content.substr(0, 100) + "</p>");
				$('#posts').append("<a href='post.html?blogId=" + blogId + "&postId=" + val.key.value + "'>Read more...</a>");
			});
		}, 
		"json"
	);
}

function getPostComments(){
	$.get(
		BASE_URL + "content/blog/" + blogId + "/post/" + postId + "/comment/",  
		{"type":"comment"},
		function(data) {
			$.each(data, function(key, val) {
				$('#comments').append("<p>" + val.properties.content + "</p>");
				$('#comments').append("<b>" + val.properties.name + "</b>");
				if(creatorId==USER_ID){
					$('#comments').append(" <a href='" + window.location + "' onClick='deleteComment(\"" + val.key.value + "\")'>(Delete comment)</a>");
				}
				$('#comments').append("<hr>");
			});
		}, 
		"json"
	);
}

function deleteComment(commentId){
	$.ajax({
		type: 'DELETE',
		url: BASE_URL + "content/blog/" + blogId + "/post/" + postId + "/comment/" + commentId, 
		data: {},
		async: false,
		beforeSend: function(xhr) {xhr.setRequestHeader("apiKey", API_KEY)},
		success: function(resp) {

		}, 
		dataType: "json"
	});	
}

function getBlogData(blogId){
	var result = null;
	$.ajax({
		url: BASE_URL + "content/blog/" + blogId,
		type: 'GET',
		dataType: 'json',
		async: false,
		success: function(data) {
			result = data;
		} 
	});
	return result;
}

function getAllBlogs(){
	$.get(
		BASE_URL + "content/blog", 
		{"type":"blog"},
		function(data) {
			try{
				$.each(data, function(key, val) {
					$('#blogList').append("<li><a href='blog.html?blogId=" + val.key.value + "'>" + val.properties.title + "</a></li>");
				});
			}catch(err){
			}
		}, 
		"json"
	);
}

function getPostData(postId, blogId){
	var result = null;
	$.ajax({
		url: BASE_URL + "content/blog/" + blogId + "/post/" + postId,
		type: 'GET',
		dataType: 'json',
		async: false,
		success: function(data) {
			result = data;
		} 
	});
	return result;
}


function getUser(){
	$.ajax({
		type: 'GET',
		url: BASE_URL + "user?method=getUser&destinationUrl=" + window.location,
		dataType: 'json',
		success: function(json) {
			var userId=json[0].userId;
			if(userId==-1){
				$('#navList').append("<li><a href='" +json[1].loginUrl + "'>Login</a></li>");
			}else{
				USER_ID=userId;
				$('#navList').append("<li><a href='" +json[1].logoutUrl + "'>Logout</a></li>");
			}
		},
		data: {},
		async: false
	});
}